curl_global_init(3)

NAME
curl_global_init - Global libcurl initialisation

SYNOPSIS
#include <curl/curl.h>

CURLcode curl_global_init(long flags);

DESCRIPTION
This function sets up the program environment that libcurl needs. Think of it as an extension of the library loader.

This function must be called at least once within a program (a program is all the code that shares a memory space) before the program calls any other function in libcurl. The environment it sets up is constant for the life of the program and is the same for every program, so multiple calls have the same effect as one call.

The flags option is a bit pattern that tells libcurl exactly what features to init, as described below. Set the desired bits by ORing the values together. In normal operation, you must specify CURL_GLOBAL_ALL. Don't use any other value unless you are familiar with it and mean to control internal operations of libcurl.

This function is not thread safe. You must not call it when any other thread in the program (i.e. a thread sharing the same memory) is running. This doesn't just mean no other thread that is using libcurl. Because curl_global_init() calls functions of other libraries that are similarly thread unsafe, it could conflict with any other thread that uses these other libraries.

See the description in libcurl(3) of global environment requirements for details of how to use this function.

FLAGS

CURL_GLOBAL_ALL
    Initialize everything possible. This sets all known bits.

CURL_GLOBAL_SSL
    Initialize SSL

CURL_GLOBAL_WIN32
    Initialize the Win32 socket libraries.

CURL_GLOBAL_NOTHING
    Initialise nothing extra. This sets no bit.

RETURN VALUE
If this function returns non-zero, something went wrong and you cannot use the other curl functions.

SEE ALSO
curl_global_init_mem(3), curl_global_cleanup(3), curl_easy_init(3) libcurl(3)